using System.Net;
using Common;

namespace Router
{
    class API
    {
        public static void SendString(string address, int port, string text)
        {
            var endPoint = new IPEndPoint(IPAddress.Parse(address), port);
            UDPClientPool.AsyncSendString(endPoint, [text]);
        }

        public static void SendAddrPackage(
            string address,
            int port,
            WebProtocol.BurstType burstType,
            byte commandID,
            bool isWrite,
            byte burstLength,
            UInt32 devAddress)
        {
            WebProtocol.SendAddrPackOptions opts;
            opts.burstType = burstType;
            opts.commandID = commandID;
            opts.isWrite = isWrite;
            opts.burstLength = burstLength;
            opts.address = devAddress;

            var endPoint = new IPEndPoint(IPAddress.Parse(address), port);
            UDPClientPool.SendAddrPack(endPoint, new WebProtocol.SendAddrPackage(opts));
        }

        public static void SendDataPackage(string address, int port, string data)
        {
            var endPoint = new IPEndPoint(IPAddress.Parse(address), port);
            UDPClientPool.SendDataPack(endPoint,
                new WebProtocol.SendDataPackage(NumberProcessor.StringToBytes(data).Value));
        }
    }
}
